function TransformYawByInput(y)
y=y or 1
if lockInputs then return y end
local Forward = InputDown("up") 
local Back = InputDown("down")
local Left = InputDown("left")
local Right = InputDown("right")
if Forward then
if Left then
y = y + 45
elseif Right then
y = y - 45
end
elseif Back then 
y = y + 180
if Left  then
y = y - 45
elseif Right  then
y = y + 45
end
else
if Left then
y = y + 90
elseif Right then
y = y - 90
else 
return 
end
end
return math.fmod(y + 180, 360) - 180
end
function IsDirectionalInputDown() 
if lockInputs then return false end
return InputDown("up") or InputDown("down") or InputDown("left") or InputDown("right")
end
function GetForwardDirection() 
local camera = GetCameraTransform()
local parentpoint = TransformToParentPoint(camera, Vec(0, 0, 1))
return VecNormalize(VecSub(camera.pos, parentpoint)), camera
end
function GetPosWeAreLookingAt()
local direction, camera = GetForwardDirection() 
local hit, dist = QueryRaycast(camera.pos, direction, 666)
if hit then 
return TransformToParentPoint(camera, Vec(0, 0, -dist))
end
return nil 
end
function GetObjectWeAreLookingAt()
local direction, camera = GetForwardDirection() 
local hit, dist, normal, shape = QueryRaycast(camera.pos, direction, 666)
if hit then 
return GetShapeBody(shape), dist
end
return nil 
end
function seedToRGB(y)
local rgb = {}
rgb.R = math.sin(y + 0) * 0.5 + 0.5
rgb.G = math.sin(y + 2) * 0.5 + 0.5
rgb.B = math.sin(y + 4) * 0.5 + 0.5
return rgb 
end
function GetBodyCenter(body)
local min, max = GetBodyBounds(body)
return VecLerp(min, max, 0.5)
end
function VecDist(vecA, vecB)
local delta = VecSub(vecA, vecB)
return math.sqrt(delta[1]^2 + delta[2]^2 + delta[3]^2)
end
function GetBodySize(body)
local min, max = GetBodyBounds(body)
return VecDist(min, max)
end
function MathRound(value)
return math.floor(value+0.5)
end
function Clamp(a, x, y) 
if a < x then a = x end 
if a > y then a = y end 
return a
end
function animateDvd(dvd, dt)
dvd.x = dvd.x + dvd.speedx * dt
dvd.y = dvd.y + dvd.speedy * dt
if dvd.x < 0 or dvd.x + dvd.width > UiWidth() then
dvd.speedx = -dvd.speedx
end
if dvd.y < 0 or dvd.y + dvd.height > UiHeight() then
dvd.speedy = -dvd.speedy
end
return dvd
end
function DirtyWriteAccessCheck(key)
local d = GetString(key)
SetString(key, "tearware")
if GetString(key) == "tearware" then
SetString(key, d)
return true
end
return false
end
function InputCapitalization(input)
for i=1, #ghettoKeyMap do
if input == ghettoKeyMap[i][1] then
if InputDown("shift") then
return ghettoKeyMap[i][3]
else
return ghettoKeyMap[i][2]
end
end
end
return input
end
function ModifyString(base, cursorPos)
if cursorPos == nil then 
cursorPos = #base + 1
inputStringCursorSwitchTimer = 0
inputStringDrawCursor = false
elseif inputStringCursorTimer <= GetTime() then
if InputDown("leftarrow") then 
cursorPos = Clamp(cursorPos - 1, 1, #base+1)
inputStringCursorTimer = GetTime() + 0.1
inputStringCursorSwitchTimer = 0
inputStringDrawCursor = false
elseif InputDown("rightarrow")then 
cursorPos = Clamp(cursorPos + 1, 1, #base+1)
inputStringCursorTimer = GetTime() + 0.1
inputStringCursorSwitchTimer = 0
inputStringDrawCursor = false
end
end
local old_state = base
local stringEnd = string.sub(base, cursorPos)
local base = string.sub(base, 1, cursorPos - 1)
local input = InputLastPressedKey()
if #input > 1 then
if input == "space" then
base = base .. " "
cursorPos = Clamp(cursorPos + 1, 1, #old_state+2)
end
elseif input ~= nil and input ~= "" then
base = base .. InputCapitalization(input)
cursorPos = Clamp(cursorPos + 1, 1, #old_state+2)
else
for i=1, #keysNotInLastPressedKey do
if InputPressed(keysNotInLastPressedKey[i][1]) then
if InputDown("shift") then
base = base .. keysNotInLastPressedKey[i][3]
else
base = base .. keysNotInLastPressedKey[i][2]
end
cursorPos = Clamp(cursorPos + 1, 1, #old_state+2)
end
end
if InputDown("backspace") then
if #base > 0 then
if inputStringBackspaceTimer <= GetTime() then
base = base:sub(1, -2)
inputStringBackspaceTimer = GetTime() + 0.1
cursorPos = Clamp(cursorPos - 1, 1, #old_state+2)
end
end
end
end
base = base .. stringEnd
local modified = not (old_state == base)
if modified then 
inputStringCursorSwitchTimer = 0
inputStringDrawCursor = false
end
return base, modified, cursorPos
end
function DrawInputStringCursor(base, cursorPos)
if cursorPos == nil then return end
if inputStringCursorSwitchTimer <= GetTime() then
inputStringCursorSwitchTimer = GetTime() + 0.5
inputStringDrawCursor = not inputStringDrawCursor
end
if not inputStringDrawCursor then return end
UiPush()
local base = string.sub(base, 1, cursorPos - 1)
base = base .. "dot"
local basex, basey = UiGetTextSize(base)
local dotx, doty = UiGetTextSize("dot") 
local translatedOffset = basex - dotx + 3
UiTranslate(translatedOffset, 0)
UiRect(2, basey)
UiPop()
end
function DebugDrawCube(Min, Max, r, g, b, a)
r=r or 1
g=g or 1
b=b or 1
a=a or 1
DebugLine(Vec(Min[1],Min[2],Min[3]),Vec(Min[1],Min[2],Max[3]),r,g,b,a)
DebugLine(Vec(Min[1],Min[2],Min[3]),Vec(Min[1],Max[2],Min[3]),r,g,b,a)
DebugLine(Vec(Min[1],Min[2],Min[3]),Vec(Max[1],Min[2],Min[3]),r,g,b,a)
DebugLine(Vec(Max[1],Max[2],Min[3]),Vec(Max[1],Max[2],Max[3]),r,g,b,a)
DebugLine(Vec(Max[1],Min[2],Max[3]),Vec(Max[1],Max[2],Max[3]),r,g,b,a)
DebugLine(Vec(Min[1],Max[2],Max[3]),Vec(Max[1],Max[2],Max[3]),r,g,b,a)
DebugLine(Vec(Max[1],Min[2],Min[3]),Vec(Max[1],Min[2],Max[3]),r,g,b,a)
DebugLine(Vec(Min[1],Max[2],Min[3]),Vec(Max[1],Max[2],Min[3]),r,g,b,a)
DebugLine(Vec(Min[1],Min[2],Max[3]),Vec(Min[1],Max[2],Max[3]),r,g,b,a)
DebugLine(Vec(Min[1],Max[2],Min[3]),Vec(Min[1],Max[2],Max[3]),r,g,b,a)
DebugLine(Vec(Min[1],Min[2],Max[3]),Vec(Max[1],Min[2],Max[3]),r,g,b,a)
DebugLine(Vec(Max[1],Min[2],Min[3]),Vec(Max[1],Max[2],Min[3]),r,g,b,a)
end
function DebugDrawCylinder(Min, Max, r, g, b, a)
r=r or 1
g=g or 1
b=b or 1
a=a or 1
local center = VecLerp(Min, Max, 0.5)
local radius = VecDist( {Min[1], 0, Min[3] }, { Max[1], 0, Max[3]}) / 2
local height = Max[2] - Min[2]
local numSegments = 16
local angleIncrement = (2 * math.pi) / numSegments
local currentAngle = 0
for i = 1, numSegments do
local x1 = center[1] + (math.cos(currentAngle) * radius)
local z1 = center[3] + (math.sin(currentAngle) * radius)
local x2 = center[1] + (math.cos(currentAngle + angleIncrement) * radius)
local z2 = center[3] + (math.sin(currentAngle + angleIncrement) * radius)
DebugLine(Vec(x1, Min[2], z1), Vec(x1, Max[2], z1), r, g, b, a)
DebugLine(Vec(x1, Min[2], z1), Vec(x2, Min[2], z2), r, g, b, a)
DebugLine(Vec(x1, Max[2], z1), Vec(x2, Max[2], z2), r, g, b, a)
currentAngle = currentAngle + angleIncrement
end
end
function TWInputDown(input)
if lockInputs then return false end
return InputDown(input)
end
function TWInputPressed(input)
if lockInputs then return false end
return InputPressed(input)
end